#ifndef OUTPUT_H_
#define OUTPUT_H_

#include "structs.h"

#define MESH_PATH "/Mesh"
#define INITIAL_PATH "/InitialResults"
#define INTERMEDIATE_PATH "/IntermediateResults"
#define FINAL_PATH "/FinalResults"
#define TRANS_PATH "/TimeStepResults"
#define MEANS_PATH "Means"
#define INSTANT_PATH "InstantValues"
#define PROPERTIES_PATH "Properties"

PetscErrorCode OutputInitialField();
PetscErrorCode OutputIntermediateField(PetscInt);
PetscErrorCode OutputFinalField();
PetscErrorCode OutputTimeStep();
PetscErrorCode Log(LogLevel, const char *, ...);
PetscErrorCode LogView(LogLevel, PetscObject, const char *, ...);
PetscErrorCode LogSync(LogLevel, const char *, ...);

#endif /* OUTPUT_H_ */
