#ifndef PROPS_H_
#define PROPS_H_

#include "structs.h"

PetscErrorCode CreateProp(Ptr_Patch Patch, ktypeProp ktype,
    StorageType storage, PetscReal value, PetscErrorCode(*Funct)
    (Ptr_Prop Prop), ktypeIp kip, PetscReal linrlx,
		PetscTruth calcMeans, Ptr_Prop *ret);
PetscErrorCode SetProp(Ptr_Prop prop, Ptr_Patch patch, ktypeProp ktype,
    StorageType storage, PetscReal value, PetscErrorCode(*Funct)
    (Ptr_Prop Prop), ktypeIp kip, PetscReal linrlx, PetscTruth calcMeans);
PetscErrorCode DeleteProp(Ptr_Prop prop);
PetscErrorCode DestroyProps();
PetscErrorCode EvaluateAllProp(ktypeProp ktype);
PetscErrorCode ValueFaceProp(Ptr_Prop prop, PetscInt idof, PetscInt ineighb,
		PetscInt icell, PetscReal *value);
PetscErrorCode ValueFacePropBackward(Ptr_Prop prop, PetscInt idof,
		PetscInt idir, PetscInt icell, PetscReal *value);
PetscErrorCode ValueFacePropForward(Ptr_Prop prop, PetscInt idof,
		PetscInt idir, PetscInt icell, PetscReal *value);

#endif
