#ifndef VAR_H_
#define VAR_H_

#include "structs.h"

PetscErrorCode CreateVar(const char *name, ktypeIp interpType, PetscReal minValue, PetscReal maxValue,
		PetscReal linRelax, PetscReal fdtRelax, PetscReal resRef, PetscReal corrRef,
		Ptr_Prop initValues, Ptr_Prop gamma, Ptr_Var *ret);
PetscErrorCode VarSetInterpolation(Ptr_Var variable, ktypeIp interpType);
PetscErrorCode VarSetLimits(Ptr_Var variable, PetscReal minValue, PetscReal maxValue);
PetscErrorCode VarSetRelaxation(Ptr_Var variable, PetscReal linRelax, PetscReal fdtRelax);
PetscErrorCode VarSetReference(Ptr_Var variable, PetscReal resRef, PetscReal corrRef);
PetscErrorCode VarSetProperties(Ptr_Var variable,
		Ptr_Prop initValues, Ptr_Prop gamma);
PetscErrorCode VarSetInitValues(Ptr_Var variable, Ptr_Prop initValues);
PetscErrorCode VarSetGamma(Ptr_Var variable, Ptr_Prop gamma);
PetscErrorCode GetVariableByName(const char *name, Ptr_Var *ret);
PetscErrorCode GetVariableByIndex(PetscInt index, Ptr_Var *ret);
PetscErrorCode VarToSysPhi(PetscInt ivar);
PetscErrorCode SysToVarPhi(PetscInt ivar);
PetscErrorCode VarGetArrayPointer();
PetscErrorCode VarRestoreArrayPointer();
PetscErrorCode LimitValues();
PetscErrorCode ValueFaceVar(PetscInt ivar, PetscInt ineighb, PetscInt icell,
		PetscReal *value);
PetscErrorCode ValueFaceVarBackward(PetscInt ivar, PetscInt idir,
		PetscInt icell, PetscReal *value);
PetscErrorCode ValueFaceVarForward(PetscInt ivar, PetscInt idir,
		PetscInt icell, PetscReal *value);

#endif /* VAR_H_ */
