#include "structs.h"

St_Input Input;
St_Grid Grid;
St_Geom Geom;
St_Trans Trans;

Ptr_Var firstVar;
Ptr_Var varU, varV, varW, varP, varT, varKE, varEP;

St_Interp Interp;

St_Sys CoupledSys;
St_Sys SegregatedSys;

St_Global Global;
St_Local Local;

/*D
  DomainPatch - Pointer to the patch representing the whole domain of
  the problem.

  Level: advanced

.seealso St_Patch
D*/
Ptr_Patch DomainPatch;

/*D
  DomainPatchDim - TODO document me!!

  Level: advanced

.seealso St_Patch
D*/
Ptr_Patch DomainPatchDim;

/*D
  DomainPatchVar - TODO document me!!

  Level: advanced

.seealso St_Patch
D*/
Ptr_Patch DomainPatchVar;

/*D
  Conv - Property for the evaluation of the convective term of the
  discretized Navier-Stokes equations.

  Level: advanced

.seealso St_Prop, ConvFunct
D*/
Ptr_Prop Conv;
/*D
  Diff - Property for the evaluation of the diffusive term of the
  discretized Navier-Stokes equations.

  Level: advanced

.seealso St_Prop, DiffFunct
D*/
Ptr_Prop Diff;
/*D
  MIPresCont - TODO document me!!

  Level: advanced

.seealso St_Prop, MIPresContFunct
D*/
Ptr_Prop MIPresCont;
/*D
  Omicp - TODO document me!!

  Level: advanced

.seealso St_Prop, OmicpFunct
D*/
Ptr_Prop Omicp;
/*D
  Omica - TODO document me!!

  Level: advanced

.seealso St_Prop, OmicaFunct
D*/
Ptr_Prop Omica;
/*D
  Tmic1 - TODO document me!!

  Level: advanced

.seealso St_Prop, Tmic1Funct
D*/
Ptr_Prop Tmic1;
/*D
  Tmic2 - TODO document me!!

  Level: advanced

.seealso St_Prop, Tmic2Funct
D*/
Ptr_Prop Tmic2;
/*D
  MICorr - TODO document me!!

  Level: advanced

.seealso St_Prop, MICorrFunct
D*/
Ptr_Prop MICorr;
/*D
  TransExp1 - TODO document me!!

  Level: advanced

.seealso St_Prop, TransExp1Funct
D*/
Ptr_Prop TransExp1;
/*D
  TransExpEUL2 - TODO document me!!

  Level: advanced

.seealso St_Prop, TransExpEUL2Funct
D*/
Ptr_Prop TransExpEUL2;
/*D
  TransExpADM2 - TODO document me!!

  Level: advanced

.seealso St_Prop, TransExpADM2Funct
D*/
Ptr_Prop TransExpADM2;
/*D
  TransExpADM3 - TODO document me!!

  Level: advanced

.seealso St_Prop, TransExpADM3Funct
D*/
Ptr_Prop TransExpADM3;
/*D
  TransExpADMaux - TODO document me!!

  Level: advanced

.seealso St_Prop, TransExpADMauxFunct
D*/
Ptr_Prop TransExpADMaux;
/*D
  ViscTLES - Property for the evaluation of the turbulent viscosity
  using the Smagorinsky LES model.

  Level: advanced

.seealso St_Prop, ViscTLESFunct
D*/
Ptr_Prop ViscTLES;
/*D
  ViscTKE - Property for the evaluation of the turbulent viscosity
  using the K-Epsilon RANS model.

  Level: advanced

.seealso St_Prop, ViscTKE
D*/
Ptr_Prop ViscTKE;
/*D
  TurmodPk - Pk is the volumetric production rate of KE by shear forces.

  Level: advanced

.seealso St_Prop, TurmodPkFunct
D*/
Ptr_Prop TurmodPk;
/*D
  TurmodGb - Gb is the volumetric production rate of KE by gravitational
  forces interacting with density gradients.

  Level: advanced

.seealso St_Prop, TurmodGbFunct
D*/
Ptr_Prop TurmodGb;
/*D
  Rho - Property for the evaluation of the density.

  Level: advanced

.seealso St_Prop, RhoFunct
D*/
Ptr_Prop Rho;
/*D
  Nuss - Property for the evaluation of the Nusselt number.

  Level: advanced

.seealso St_Prop, NussFunct
D*/
Ptr_Prop Nuss;
/*D
  Pscomp - TODO document me!!

  Level: advanced

.seealso St_Prop, PscompFunct
D*/
Ptr_Prop Pscomp;
/*D
  MIrelax - TODO document me!!

  Level: advanced

.seealso St_Prop, MIrelaxFunct
D*/
Ptr_Prop MIrelax;

/*D
  dpdx - Property representing the variable mass flux dp/dx

  Level: advanced

.seealso St_Prop, DPDXFunct
D*/
Ptr_Prop dpdx;

/*D
  utau2 - Property representing the value of utau^2, used for
  the calculation of the dpdx property.

  Level: advanced

.seealso St_Prop, Utau2Funct, dpdx, utau2prev
D*/
Ptr_Prop utau2;

/*D
  utau2prev - Property representing the value of utau^2 in the previous
  iteration, used for the calculation of the dpdx property.

  Level: advanced

.seealso St_Prop, Utau2PrevFunct, utau2, dpdx
D*/
Ptr_Prop utau2prev;

/*D
  outer_its - Number of outer iterations performed. This number is set
  to 0 at the beginning of each time step.

  Level: advanced
D*/
PetscInt outer_its; /*! Number of outer iterations. */

/*D
  logger - PETSc object used for logging. Is preferable to use the Log,
  LogSync and LogView functions instead of using the object directly.

  Level: advanced

.seealso Log, LogSync, LogView
D*/
PetscViewer logger;

/*D
  instantMeans - Set of vectors containing the means of the instant values
  for each variable.

  Level: advanced
D*/
Vec *instantMeans;
/*D
  instantSums - Set of vectors containing the sum of all instant values
  for each variable.

  Level: advanced
D*/
Vec *instantSums;
/*D
  varianceSums - Set of vectors containing the sum of all variance values
  for each variable.

  Level: advanced
D*/
Vec *varianceSums;
